"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkupEditorComponent = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const MarkupEditorComponent = function MarkupEditorComponent({ editor, autofocus, className, children }) {
    const ref = react_1.default.useRef(null);
    // insert editor to dom
    react_1.default.useLayoutEffect(() => {
        const domElem = editor.markupEditor.cm.dom;
        if (ref.current) {
            ref.current.appendChild(domElem);
        }
        return () => {
            domElem.remove();
        };
    }, [editor.markupEditor]);
    // update editor after connecting to dom
    react_1.default.useEffect(() => {
        editor.markupEditor.cm.requestMeasure();
        if (autofocus) {
            editor.markupEditor.focus();
        }
    }, [editor.markupEditor]);
    return (
    // eslint-disable-next-line jsx-a11y/click-events-have-key-events, jsx-a11y/no-static-element-interactions
    react_1.default.createElement("div", { ref: ref, className: className, onClick: (event) => {
            const target = event.target;
            if (target instanceof Element && target.classList.contains('cm-editor')) {
                editor.markupEditor.focus();
            }
        } }, children));
};
exports.MarkupEditorComponent = MarkupEditorComponent;
