"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wSelectionMenuConfigByPreset = exports.wHiddenDataByPreset = exports.wCommandMenuConfigByPreset = exports.wToolbarConfigByPreset = exports.wMermaidItemData = exports.wSelectionMenuConfig = exports.wToggleHeadingFoldingItemData = exports.wToolbarConfig = exports.wHiddenData = exports.wCommandMenuConfig = exports.wGptItemData = exports.wYfmHtmlBlockItemData = exports.wMathListItem = exports.wMathListConfig = exports.wMathBlockItemData = exports.wTabsItemData = exports.wMathInlineItemData = exports.wFileItemData = exports.wEmojiItemData = exports.wHruleItemData = exports.wImageItemData = exports.wCodeListConfig = exports.wCodeBlockItemData = exports.wCodeItemData = exports.wTableItemData = exports.wNoteItemData = exports.wListMoveListConfig = exports.wCutItemData = exports.wQuoteItemData = exports.wLinkItemData = exports.wCheckboxItemData = exports.wListsListConfig = exports.wHeadingListConfig = exports.wTextItemData = exports.wBiusGroupConfig = exports.wMarkedItemData = exports.wMonospaceItemData = exports.wStrikethroughItemData = exports.wUnderlineItemData = exports.wItalicItemData = exports.wBoldItemData = exports.wHistoryGroupConfig = void 0;
const extensions_1 = require("../../extensions");
const constants_1 = require("../../extensions/additional/GPT/constants");
const hints_1 = require("../../i18n/hints");
const menubar_1 = require("../../i18n/menubar");
const shortcuts_1 = require("../../shortcuts");
const types_1 = require("../../toolbar/types");
const WToolbarColors_1 = require("../toolbar/wysiwyg/WToolbarColors");
const WToolbarTextSelect_1 = require("../toolbar/wysiwyg/WToolbarTextSelect");
const action_names_1 = require("./action-names");
const icons_1 = require("./icons");
exports.wHistoryGroupConfig = [
    {
        id: action_names_1.ActionName.undo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'undo'),
        icon: icons_1.icons.undo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Undo),
        hintWhenDisabled: false,
        exec: (e) => e.actions.undo.run(),
        isActive: (e) => e.actions.undo.isActive(),
        isEnable: (e) => e.actions.undo.isEnable(),
    },
    {
        id: action_names_1.ActionName.redo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'redo'),
        icon: icons_1.icons.redo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Redo),
        hintWhenDisabled: false,
        exec: (e) => e.actions.redo.run(),
        isActive: (e) => e.actions.redo.isActive(),
        isEnable: (e) => e.actions.redo.isEnable(),
    },
];
/** Bold, Italic, Underline, Strike buttons group */
exports.wBoldItemData = {
    id: action_names_1.ActionName.bold,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'bold'),
    icon: icons_1.icons.bold,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Bold),
    exec: (e) => e.actions.bold.run(),
    isActive: (e) => e.actions.bold.isActive(),
    isEnable: (e) => e.actions.bold.isEnable(),
};
exports.wItalicItemData = {
    id: action_names_1.ActionName.italic,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'italic'),
    icon: icons_1.icons.italic,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Italic),
    exec: (e) => e.actions.italic.run(),
    isActive: (e) => e.actions.italic.isActive(),
    isEnable: (e) => e.actions.italic.isEnable(),
};
exports.wUnderlineItemData = {
    id: action_names_1.ActionName.underline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'underline'),
    icon: icons_1.icons.underline,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Underline),
    exec: (e) => e.actions.underline.run(),
    isActive: (e) => e.actions.underline.isActive(),
    isEnable: (e) => e.actions.underline.isEnable(),
};
exports.wStrikethroughItemData = {
    id: action_names_1.ActionName.strike,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'strike'),
    icon: icons_1.icons.strikethrough,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Strike),
    exec: (e) => e.actions.strike.run(),
    isActive: (e) => e.actions.strike.isActive(),
    isEnable: (e) => e.actions.strike.isEnable(),
};
exports.wMonospaceItemData = {
    id: action_names_1.ActionName.mono,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mono'),
    icon: icons_1.icons.mono,
    exec: (e) => e.actions.mono.run(),
    isActive: (e) => e.actions.mono.isActive(),
    isEnable: (e) => e.actions.mono.isEnable(),
};
exports.wMarkedItemData = {
    id: action_names_1.ActionName.mark,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mark'),
    icon: icons_1.icons.mark,
    exec: (e) => e.actions.mark.run(),
    isActive: (e) => e.actions.mark.isActive(),
    isEnable: (e) => e.actions.mark.isEnable(),
};
exports.wBiusGroupConfig = [
    exports.wBoldItemData,
    exports.wItalicItemData,
    exports.wUnderlineItemData,
    exports.wStrikethroughItemData,
    exports.wMonospaceItemData,
    exports.wMarkedItemData,
];
exports.wTextItemData = {
    id: action_names_1.ActionName.paragraph,
    title: menubar_1.i18n.bind(null, 'text'),
    icon: icons_1.icons.text,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Text),
    exec: (e) => e.actions.toParagraph.run(),
    isActive: (e) => e.actions.toParagraph.isActive(),
    isEnable: (e) => e.actions.toParagraph.isEnable(),
    doNotActivateList: true,
};
exports.wHeadingListConfig = {
    icon: icons_1.icons.headline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'heading'),
    data: [
        exports.wTextItemData,
        {
            id: action_names_1.ActionName.heading1,
            title: menubar_1.i18n.bind(null, 'heading1'),
            icon: icons_1.icons.h1,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading1),
            exec: (e) => e.actions.toH1.run(),
            isActive: (e) => e.actions.toH1.isActive(),
            isEnable: (e) => e.actions.toH1.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading2,
            title: menubar_1.i18n.bind(null, 'heading2'),
            icon: icons_1.icons.h2,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading2),
            exec: (e) => e.actions.toH2.run(),
            isActive: (e) => e.actions.toH2.isActive(),
            isEnable: (e) => e.actions.toH2.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading3,
            title: menubar_1.i18n.bind(null, 'heading3'),
            icon: icons_1.icons.h3,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading3),
            exec: (e) => e.actions.toH3.run(),
            isActive: (e) => e.actions.toH3.isActive(),
            isEnable: (e) => e.actions.toH3.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading4,
            title: menubar_1.i18n.bind(null, 'heading4'),
            icon: icons_1.icons.h4,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading4),
            exec: (e) => e.actions.toH4.run(),
            isActive: (e) => e.actions.toH4.isActive(),
            isEnable: (e) => e.actions.toH4.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading5,
            title: menubar_1.i18n.bind(null, 'heading5'),
            icon: icons_1.icons.h5,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading5),
            exec: (e) => e.actions.toH5.run(),
            isActive: (e) => e.actions.toH5.isActive(),
            isEnable: (e) => e.actions.toH5.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading6,
            title: menubar_1.i18n.bind(null, 'heading6'),
            icon: icons_1.icons.h6,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading6),
            exec: (e) => e.actions.toH6.run(),
            isActive: (e) => e.actions.toH6.isActive(),
            isEnable: (e) => e.actions.toH6.isEnable(),
        },
    ],
};
exports.wListsListConfig = {
    icon: icons_1.icons.bulletList,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'list'),
    data: [
        {
            id: action_names_1.ActionName.bulletList,
            title: menubar_1.i18n.bind(null, 'ulist'),
            icon: icons_1.icons.bulletList,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.BulletList),
            exec: (e) => e.actions.toBulletList.run(),
            isActive: (e) => e.actions.toBulletList.isActive(),
            isEnable: (e) => e.actions.toBulletList.isEnable(),
        },
        {
            id: action_names_1.ActionName.orderedList,
            title: menubar_1.i18n.bind(null, 'olist'),
            icon: icons_1.icons.orderedList,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.OrderedList),
            exec: (e) => e.actions.toOrderedList.run(),
            isActive: (e) => e.actions.toOrderedList.isActive(),
            isEnable: (e) => e.actions.toOrderedList.isEnable(),
        },
        {
            id: action_names_1.ActionName.sinkListItem,
            title: menubar_1.i18n.bind(null, 'list__action_sink'),
            hintWhenDisabled: () => (0, menubar_1.i18n)('list_action_disabled'),
            icon: icons_1.icons.sink,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.SinkListItem),
            exec: (e) => e.actions.sinkListItem.run(),
            isActive: (e) => e.actions.sinkListItem.isActive(),
            isEnable: (e) => e.actions.sinkListItem.isEnable(),
        },
        {
            id: action_names_1.ActionName.liftListItem,
            title: menubar_1.i18n.bind(null, 'list__action_lift'),
            hintWhenDisabled: () => (0, menubar_1.i18n)('list_action_disabled'),
            icon: icons_1.icons.lift,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.LiftListItem),
            exec: (e) => e.actions.liftListItem.run(),
            isActive: (e) => e.actions.liftListItem.isActive(),
            isEnable: (e) => e.actions.liftListItem.isEnable(),
        },
    ],
};
exports.wCheckboxItemData = {
    id: action_names_1.ActionName.checkbox,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'checkbox'),
    icon: icons_1.icons.checklist,
    exec: (e) => e.actions.addCheckbox.run(),
    isActive: (e) => e.actions.addCheckbox.isActive(),
    isEnable: (e) => e.actions.addCheckbox.isEnable(),
};
exports.wLinkItemData = {
    id: action_names_1.ActionName.link,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'link'),
    icon: icons_1.icons.link,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Link),
    exec: (e) => e.actions.addLink.run(),
    isActive: (e) => e.actions.addLink.isActive(),
    isEnable: (e) => e.actions.addLink.isEnable(),
};
exports.wQuoteItemData = {
    id: action_names_1.ActionName.quote,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'quote'),
    icon: icons_1.icons.quote,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Quote),
    exec: (e) => e.actions.quote.run(),
    isActive: (e) => e.actions.quote.isActive(),
    isEnable: (e) => e.actions.quote.isEnable(),
};
exports.wCutItemData = {
    id: action_names_1.ActionName.yfm_cut,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'cut'),
    icon: icons_1.icons.cut,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Cut),
    exec: (e) => e.actions.toYfmCut.run(),
    isActive: (e) => e.actions.toYfmCut.isActive(),
    isEnable: (e) => e.actions.toYfmCut.isEnable(),
};
exports.wListMoveListConfig = {
    icon: icons_1.icons.lift,
    withArrow: true,
    title: 'Move list item',
    data: [
        {
            id: action_names_1.ActionName.sinkListItem,
            title: 'Sink list item',
            icon: icons_1.icons.sink,
            exec: (e) => e.actions.sinkListItem.run(),
            isActive: (e) => e.actions.sinkListItem.isActive(),
            isEnable: (e) => e.actions.sinkListItem.isEnable(),
        },
        {
            id: action_names_1.ActionName.liftListItem,
            title: 'Lift list item',
            icon: icons_1.icons.lift,
            exec: (e) => e.actions.liftListItem.run(),
            isActive: (e) => e.actions.liftListItem.isActive(),
            isEnable: (e) => e.actions.liftListItem.isEnable(),
        },
    ],
};
exports.wNoteItemData = {
    id: action_names_1.ActionName.yfm_note,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'note'),
    icon: icons_1.icons.note,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Note),
    exec: (e) => e.actions.toYfmNote.run(),
    isActive: (e) => e.actions.toYfmNote.isActive(),
    isEnable: (e) => e.actions.toYfmNote.isEnable(),
};
exports.wTableItemData = {
    id: action_names_1.ActionName.table,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'table'),
    icon: icons_1.icons.table,
    exec: (e) => e.actions.createYfmTable.run(),
    isActive: (e) => e.actions.createYfmTable.isActive(),
    isEnable: (e) => e.actions.createYfmTable.isEnable(),
};
exports.wCodeItemData = {
    id: action_names_1.ActionName.code_inline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'code_inline'),
    icon: icons_1.icons.code,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Code),
    exec: (e) => e.actions.code.run(),
    isActive: (e) => e.actions.code.isActive(),
    isEnable: (e) => e.actions.code.isEnable(),
};
exports.wCodeBlockItemData = {
    id: action_names_1.ActionName.code_block,
    title: menubar_1.i18n.bind(null, 'codeblock'),
    icon: icons_1.icons.codeBlock,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.CodeBlock),
    exec: (e) => e.actions.toCodeBlock.run(),
    isActive: (e) => e.actions.toCodeBlock.isActive(),
    isEnable: (e) => e.actions.toCodeBlock.isEnable(),
};
exports.wCodeListConfig = {
    icon: icons_1.icons.code,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'code'),
    data: [exports.wCodeItemData, exports.wCodeBlockItemData],
};
exports.wImageItemData = {
    id: action_names_1.ActionName.image,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'image'),
    icon: icons_1.icons.image,
    exec: (e) => e.actions.addImageWidget.run(),
    isActive: (e) => e.actions.addImageWidget.isActive(),
    isEnable: (e) => e.actions.addImageWidget.isEnable(),
};
exports.wHruleItemData = {
    id: action_names_1.ActionName.horizontalrule,
    title: menubar_1.i18n.bind(null, 'hrule'),
    icon: icons_1.icons.horizontalRule,
    exec: (e) => e.actions.hRule.run(),
    isActive: (e) => e.actions.hRule.isActive(),
    isEnable: (e) => e.actions.hRule.isEnable(),
};
exports.wEmojiItemData = {
    id: action_names_1.ActionName.emoji,
    title: menubar_1.i18n.bind(null, 'emoji'),
    icon: icons_1.icons.emoji,
    exec: (e) => e.actions.openEmojiSuggest.run({}),
    isActive: (e) => e.actions.openEmojiSuggest.isActive(),
    isEnable: (e) => e.actions.openEmojiSuggest.isEnable(),
};
exports.wFileItemData = {
    id: action_names_1.ActionName.file,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'file'),
    icon: icons_1.icons.file,
    exec: (e) => e.actions.addFile.run(),
    isActive: (e) => e.actions.addFile.isActive(),
    isEnable: (e) => e.actions.addFile.isEnable(),
};
exports.wMathInlineItemData = {
    id: action_names_1.ActionName.math_inline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'math_inline'),
    icon: icons_1.icons.functionInline,
    hint: () => `${hints_1.i18n.bind(null, 'math_hint')()} ${hints_1.i18n.bind(null, 'math_hint_katex')()}`,
    exec: (e) => e.actions.addMathInline.run(),
    isActive: (e) => e.actions.addMathInline.isActive(),
    isEnable: (e) => e.actions.addMathInline.isEnable(),
};
exports.wTabsItemData = {
    id: action_names_1.ActionName.tabs,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'tabs'),
    icon: icons_1.icons.tabs,
    exec: (e) => e.actions.toYfmTabs.run(),
    isActive: (e) => e.actions.toYfmTabs.isActive(),
    isEnable: (e) => e.actions.toYfmTabs.isEnable(),
};
exports.wMathBlockItemData = {
    id: action_names_1.ActionName.math_block,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'math_block'),
    icon: icons_1.icons.functionBlock,
    hint: () => `${hints_1.i18n.bind(null, 'math_hint')()} ${hints_1.i18n.bind(null, 'math_hint_katex')()}`,
    exec: (e) => e.actions.toMathBlock.run(),
    isActive: (e) => e.actions.toMathBlock.isActive(),
    isEnable: (e) => e.actions.toMathBlock.isEnable(),
};
exports.wMathListConfig = {
    icon: icons_1.icons.functionInline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'math'),
    data: [exports.wMathInlineItemData, exports.wMathBlockItemData],
};
exports.wMathListItem = Object.assign({ id: 'math', type: types_1.ToolbarDataType.ListButton }, exports.wMathListConfig);
exports.wYfmHtmlBlockItemData = {
    id: action_names_1.ActionName.yfm_html_block,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'html'),
    icon: icons_1.icons.html,
    exec: (e) => e.actions.createYfmHtmlBlock.run(),
    isActive: (e) => e.actions.createYfmHtmlBlock.isActive(),
    isEnable: (e) => e.actions.createYfmHtmlBlock.isEnable(),
};
exports.wGptItemData = {
    id: action_names_1.ActionName.gpt,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'gpt'),
    hotkey: constants_1.gptHotKeys.openGptKeyTooltip,
    icon: icons_1.icons.gpt,
    exec: (e) => e.actions.addGptWidget.run({}),
    isActive: (e) => e.actions.addGptWidget.isActive(),
    isEnable: (e) => e.actions.addGptWidget.isEnable(),
};
exports.wCommandMenuConfig = [
    ...exports.wHeadingListConfig.data,
    ...exports.wListsListConfig.data,
    exports.wLinkItemData,
    exports.wQuoteItemData,
    exports.wNoteItemData,
    exports.wCutItemData,
    exports.wCodeBlockItemData,
    exports.wCheckboxItemData,
    exports.wTableItemData,
    exports.wImageItemData,
    exports.wHruleItemData,
    exports.wEmojiItemData,
    exports.wFileItemData,
    // wMathInlineItemData,
    // wMathBlockItemData,
    exports.wTabsItemData,
];
exports.wHiddenData = exports.wCommandMenuConfig;
/** prepared wysiwyg toolbar config */
exports.wToolbarConfig = [
    exports.wHistoryGroupConfig,
    exports.wBiusGroupConfig,
    [
        Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.wHeadingListConfig),
        Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.wListsListConfig),
        {
            id: 'colorify',
            type: types_1.ToolbarDataType.ReactComponent,
            component: WToolbarColors_1.WToolbarColors,
            width: 42,
        },
        exports.wLinkItemData,
        exports.wNoteItemData,
        exports.wCutItemData,
        exports.wQuoteItemData,
        Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.wCodeListConfig),
    ],
    [exports.wImageItemData, exports.wFileItemData, exports.wTableItemData, exports.wCheckboxItemData],
];
exports.wToggleHeadingFoldingItemData = {
    id: 'folding-heading',
    type: types_1.ToolbarDataType.SingleButton,
    icon: icons_1.icons.foldingHeading,
    title: () => (0, menubar_1.i18n)('folding-heading'),
    hint: () => (0, menubar_1.i18n)('folding-heading__hint'),
    isActive: (editor) => { var _a, _b; return (_b = (_a = editor.actions.toggleHeadingFolding) === null || _a === void 0 ? void 0 : _a.isActive()) !== null && _b !== void 0 ? _b : false; },
    isEnable: (editor) => { var _a, _b; return (_b = (_a = editor.actions.toggleHeadingFolding) === null || _a === void 0 ? void 0 : _a.isEnable()) !== null && _b !== void 0 ? _b : false; },
    exec: (editor) => editor.actions.toggleHeadingFolding.run(),
    condition: 'enabled',
};
const textContextItemData = {
    id: 'text',
    type: types_1.ToolbarDataType.ReactComponent,
    component: WToolbarTextSelect_1.WToolbarTextSelect,
    width: 0,
    condition: ({ selection: { $from, $to }, schema }) => {
        if (!$from.sameParent($to))
            return false;
        const { parent } = $from;
        return parent.type === (0, extensions_1.pType)(schema) || parent.type === (0, extensions_1.headingType)(schema);
    },
};
exports.wSelectionMenuConfig = [
    [exports.wToggleHeadingFoldingItemData, textContextItemData],
    [...exports.wBiusGroupConfig, exports.wCodeItemData],
    [
        {
            id: 'colorify',
            type: types_1.ToolbarDataType.ReactComponent,
            component: WToolbarColors_1.WToolbarColors,
            width: 42,
        },
        exports.wLinkItemData,
    ],
];
exports.wMermaidItemData = {
    id: action_names_1.ActionName.mermaid,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'mermaid'),
    icon: icons_1.icons.mermaid,
    exec: (e) => e.actions.createMermaid.run(),
    isActive: (e) => e.actions.createMermaid.isActive(),
    isEnable: (e) => e.actions.createMermaid.isEnable(),
};
exports.wToolbarConfigByPreset = {
    zero: [exports.wHistoryGroupConfig],
    commonmark: [
        exports.wHistoryGroupConfig,
        [exports.wBoldItemData, exports.wItalicItemData],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.wHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.wListsListConfig),
            exports.wLinkItemData,
            exports.wQuoteItemData,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.wCodeListConfig),
        ],
    ],
    default: [
        exports.wHistoryGroupConfig,
        [exports.wBoldItemData, exports.wItalicItemData, exports.wStrikethroughItemData],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.wHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.wListsListConfig),
            exports.wLinkItemData,
            exports.wQuoteItemData,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.wCodeListConfig),
        ],
    ],
    yfm: [
        exports.wHistoryGroupConfig,
        [
            exports.wBoldItemData,
            exports.wItalicItemData,
            exports.wUnderlineItemData,
            exports.wStrikethroughItemData,
            exports.wMonospaceItemData,
        ],
        [
            Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.wHeadingListConfig),
            Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.wListsListConfig),
            exports.wLinkItemData,
            exports.wNoteItemData,
            exports.wCutItemData,
            exports.wQuoteItemData,
            Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.wCodeListConfig),
        ],
        [exports.wImageItemData, exports.wFileItemData, exports.wTableItemData, exports.wCheckboxItemData],
    ],
    full: exports.wToolbarConfig.slice(),
};
exports.wCommandMenuConfigByPreset = {
    zero: [],
    commonmark: [
        ...exports.wHeadingListConfig.data,
        ...exports.wListsListConfig.data,
        exports.wLinkItemData,
        exports.wQuoteItemData,
        exports.wCodeBlockItemData,
        exports.wHruleItemData,
    ],
    default: [
        ...exports.wHeadingListConfig.data,
        ...exports.wListsListConfig.data,
        exports.wLinkItemData,
        exports.wQuoteItemData,
        exports.wCodeBlockItemData,
        exports.wHruleItemData,
    ],
    yfm: [
        ...exports.wHeadingListConfig.data,
        ...exports.wListsListConfig.data,
        exports.wLinkItemData,
        exports.wQuoteItemData,
        exports.wNoteItemData,
        exports.wCutItemData,
        exports.wCodeBlockItemData,
        exports.wCheckboxItemData,
        exports.wTableItemData,
        exports.wImageItemData,
        exports.wHruleItemData,
        exports.wFileItemData,
        exports.wTabsItemData,
    ],
    full: exports.wCommandMenuConfig.slice(),
};
exports.wHiddenDataByPreset = {
    zero: exports.wCommandMenuConfigByPreset.zero.slice(),
    commonmark: exports.wCommandMenuConfigByPreset.commonmark.slice(),
    default: exports.wCommandMenuConfigByPreset.default.slice(),
    yfm: exports.wCommandMenuConfigByPreset.yfm.slice(),
    full: exports.wCommandMenuConfigByPreset.full.slice(),
};
exports.wSelectionMenuConfigByPreset = {
    zero: [],
    commonmark: [
        [textContextItemData],
        [exports.wBoldItemData, exports.wItalicItemData, exports.wCodeItemData],
        [exports.wLinkItemData],
    ],
    default: [
        [textContextItemData],
        [exports.wBoldItemData, exports.wItalicItemData, exports.wStrikethroughItemData, exports.wCodeItemData],
        [exports.wLinkItemData],
    ],
    yfm: [
        [textContextItemData],
        [exports.wBoldItemData, exports.wItalicItemData, exports.wStrikethroughItemData, exports.wMonospaceItemData, exports.wCodeItemData],
        [exports.wLinkItemData],
    ],
    full: exports.wSelectionMenuConfig.slice(),
};
