import React from 'react';
import { ClassNameProps } from '../../classname';
import type { MarkdownEditorMode, MarkdownEditorSplitMode } from '../types';
export declare type EditorSettingsProps = Omit<SettingsContentProps, 'onClose'> & {
    renderPreviewButton?: boolean;
    settingsVisible?: boolean;
};
export declare const EditorSettings: React.NamedExoticComponent<EditorSettingsProps>;
declare type SettingsContentProps = ClassNameProps & {
    mode: MarkdownEditorMode;
    onClose: () => void;
    onModeChange: (mode: MarkdownEditorMode) => void;
    onShowPreviewChange: (showPreview: boolean) => void;
    showPreview: boolean;
    toolbarVisibility: boolean;
    onToolbarVisibilityChange: (val: boolean) => void;
    splitMode?: MarkdownEditorSplitMode;
    splitModeEnabled?: boolean;
    onSplitModeChange?: (splitModeEnabled: boolean) => void;
};
export {};
