"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarSelect = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const components_1 = require("@gravity-ui/components");
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../../classname");
const lodash_1 = require("../../lodash");
const b = (0, classname_1.cn)('toolbar-select');
const ToolbarSelect = ({ className, editor, focus, onClick, items, }) => {
    const activeItem = items.find((item) => item.isActive(editor));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(uikit_1.Select, { size: "m", view: "clear", className: className, onOpenChange: () => {
                focus();
            }, value: activeItem ? [activeItem.id] : undefined, options: items.map((item) => ({
                data: item,
                value: item.id,
                text: (0, lodash_1.isFunction)(item.title) ? item.title() : item.title,
            })), renderOption: ({ text, data }) => {
                var _a;
                const { icon, hotkey, hint } = data;
                const hintText = (0, lodash_1.isFunction)(hint) ? hint() : hint;
                return (react_1.default.createElement("div", { "aria-label": text, className: b('item') },
                    react_1.default.createElement("div", { className: b('item-icon') },
                        react_1.default.createElement(uikit_1.Icon, { data: icon.data, size: Number((_a = icon.size) !== null && _a !== void 0 ? _a : 16) + 2 })),
                    react_1.default.createElement("div", { className: b('item-content') },
                        text,
                        react_1.default.createElement("div", { className: b('item-extra') },
                            hotkey && react_1.default.createElement(uikit_1.Hotkey, { value: hotkey }),
                            hintText && (react_1.default.createElement(components_1.HelpPopover, { content: hintText, className: b('item-hint') }))))));
            }, onUpdate: ([id]) => {
                var _a;
                (_a = items.find((item) => item.id === id)) === null || _a === void 0 ? void 0 : _a.exec(editor);
                onClick === null || onClick === void 0 ? void 0 : onClick(id);
                focus();
            } })));
};
exports.ToolbarSelect = ToolbarSelect;
