"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarFilePopup = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const FileForm_1 = require("../../../forms/FileForm");
const forms_1 = require("../../../i18n/forms");
const hooks_1 = require("../../../react-utils/hooks");
const toaster_1 = require("../../../react-utils/toaster");
const upload_1 = require("../../../utils/upload");
const placement = ['bottom-start', 'top-start', 'bottom-end', 'top-end'];
const ToolbarFilePopup = ({ className, hide, anchorRef, onSubmit, focus, onClick, uploadHandler, onSuccessUpload, }) => {
    const toaster = (0, toaster_1.useToaster)();
    const [loading, showLoading, hideLoading] = (0, hooks_1.useBooleanState)(false);
    const handleCancel = (0, react_1.useCallback)(() => {
        hide();
        focus();
    }, [focus, hide]);
    return (react_1.default.createElement(uikit_1.Popup, { open: true, onClose: handleCancel, anchorRef: anchorRef, placement: placement, className: className },
        react_1.default.createElement(FileForm_1.FileForm, { autoFocus: true, onAttach: uploadHandler &&
                ((files) => {
                    showLoading();
                    (0, upload_1.batchUploadFiles)(files, uploadHandler).then((res) => {
                        hideLoading();
                        hide();
                        onSuccessUpload === null || onSuccessUpload === void 0 ? void 0 : onSuccessUpload(res);
                    }, (error) => {
                        hideLoading();
                        toaster.add({
                            theme: 'danger',
                            name: 'toolbar_file_upload',
                            title: (0, forms_1.i18n)('file_upload_failed'),
                            content: String(error),
                        });
                    });
                }), onCancel: handleCancel, onSubmit: (data) => {
                hide();
                focus();
                onSubmit(data);
                onClick === null || onClick === void 0 ? void 0 : onClick('addFile');
            }, loading: loading })));
};
exports.ToolbarFilePopup = ToolbarFilePopup;
