"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarImagePopup = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const ImageForm_1 = require("../../../forms/ImageForm");
const forms_1 = require("../../../i18n/forms");
const hooks_1 = require("../../../react-utils/hooks");
const toaster_1 = require("../../../react-utils/toaster");
const upload_1 = require("../../../utils/upload");
const placement = ['bottom-start', 'top-start', 'bottom-end', 'top-end'];
const ToolbarImagePopup = ({ className, anchorRef, hide, onSubmit, focus, onClick, uploadImages, onSuccessUpload, }) => {
    const toaster = (0, toaster_1.useToaster)();
    const [loading, showLoading, hideLoading] = (0, hooks_1.useBooleanState)(false);
    const handleCancel = (0, react_1.useCallback)(() => {
        hide();
        focus();
    }, [focus, hide]);
    return (react_1.default.createElement(uikit_1.Popup, { open: true, anchorRef: anchorRef, onClose: handleCancel, placement: placement, className: className },
        react_1.default.createElement(ImageForm_1.ImageForm, { autoFocus: true, onAttach: uploadImages &&
                ((files) => {
                    showLoading();
                    (0, upload_1.batchUploadFiles)(files, uploadImages).then((res) => {
                        hideLoading();
                        hide();
                        onSuccessUpload === null || onSuccessUpload === void 0 ? void 0 : onSuccessUpload(res);
                    }, (err) => {
                        hideLoading();
                        toaster.add({
                            theme: 'danger',
                            name: 'toolbar_image_upload',
                            title: (0, forms_1.i18n)('image_upload_failed'),
                            content: String(err),
                        });
                    });
                }), onCancel: handleCancel, onSubmit: (data) => {
                hide();
                focus();
                onSubmit(data);
                onClick === null || onClick === void 0 ? void 0 : onClick('addImage');
            }, loading: loading })));
};
exports.ToolbarImagePopup = ToolbarImagePopup;
