import type { PopupProps } from '@gravity-ui/uikit';
import type { EditorState, PluginView } from 'prosemirror-state';
import { EditorView } from 'prosemirror-view';
import { Parser, Serializer } from 'src/core';
import type { CommonAnswer } from '../ErrorScreen/types';
import type { GptDialogProps } from '../GptDialog/GptDialog';
export declare const cnGptPopup: import("@bem-react/classname").ClassNameFormatter;
export declare type GptWidgetDecoViewParams<AnswerData extends CommonAnswer = CommonAnswer, PromptData extends unknown = unknown> = Omit<GptDialogProps<AnswerData, PromptData>, 'markup' | 'onApplyResult'> & {
    serializer: Serializer;
    parser: Parser;
} & {
    onApplyResult?: GptDialogProps['onApplyResult'];
    gptPopupContainer?: PopupProps['container'];
};
export declare class GptWidgetDecoView<AnswerData extends CommonAnswer = CommonAnswer, PromptData extends unknown = unknown> implements Required<PluginView> {
    private readonly _view;
    private readonly _renderer;
    private _decoElem;
    private _params;
    private _serializer;
    private _parser;
    private _confirmOpen;
    constructor(view: EditorView, params: GptWidgetDecoViewParams<AnswerData, PromptData>);
    update(view: EditorView, prevState: EditorState): void;
    destroy(): void;
    private _resetState;
    private _onConfirmCancel;
    private _onConfirmOk;
    private _render;
    private _onGptAnswerUpdate;
    private _onSubmit;
    private _onClose;
    private _getContentOfDecoration;
    private _getCurrentDecoration;
    private _getPluginState;
}
