"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mermaid = void 0;
const MermaidNodeView_1 = require("./MermaidNodeView");
const MermaidSpecs_1 = require("./MermaidSpecs");
const const_1 = require("./MermaidSpecs/const");
const actions_1 = require("./actions");
const Mermaid = (builder, { loadRuntimeScript }) => {
    builder.use(MermaidSpecs_1.MermaidSpecs, {
        nodeView: MermaidNodeViewFactory({ loadRuntimeScript }),
    });
    builder.addAction(const_1.MermaidAction, () => actions_1.addMermaid);
};
exports.Mermaid = Mermaid;
const MermaidNodeViewFactory = ({ loadRuntimeScript }) => () => (node, view, getPos) => {
    return new MermaidNodeView_1.WMermaidNodeView(node, view, getPos, { loadRuntimeScript });
};
