"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BehaviorPreset = void 0;
const tslib_1 = require("tslib");
const ClicksOnEdges_1 = require("./ClicksOnEdges");
const Clipboard_1 = require("./Clipboard");
const CommandMenu_1 = require("./CommandMenu");
const Cursor_1 = require("./Cursor");
const FilePaste_1 = require("./FilePaste");
const History_1 = require("./History");
const Placeholder_1 = require("./Placeholder");
const ReactRenderer_1 = require("./ReactRenderer");
const Selection_1 = require("./Selection");
const SelectionContext_1 = require("./SelectionContext");
const WidgetDecoration_1 = require("./WidgetDecoration");
tslib_1.__exportStar(require("./ClicksOnEdges"), exports);
tslib_1.__exportStar(require("./Clipboard"), exports);
tslib_1.__exportStar(require("./CommandMenu"), exports);
tslib_1.__exportStar(require("./Cursor"), exports);
tslib_1.__exportStar(require("./FilePaste"), exports);
tslib_1.__exportStar(require("./History"), exports);
tslib_1.__exportStar(require("./Placeholder"), exports);
tslib_1.__exportStar(require("./ReactRenderer"), exports);
tslib_1.__exportStar(require("./Selection"), exports);
tslib_1.__exportStar(require("./SelectionContext"), exports);
tslib_1.__exportStar(require("./WidgetDecoration"), exports);
const BehaviorPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e;
    builder
        .use(Selection_1.Selection)
        .use(Placeholder_1.Placeholder, (_a = opts.placeholder) !== null && _a !== void 0 ? _a : {})
        .use(Cursor_1.Cursor, (_b = opts.cursor) !== null && _b !== void 0 ? _b : {})
        .use(History_1.History, (_c = opts.history) !== null && _c !== void 0 ? _c : {})
        .use(Clipboard_1.Clipboard, (_d = opts.clipboard) !== null && _d !== void 0 ? _d : {})
        .use(ReactRenderer_1.ReactRendererExtension, opts.reactRenderer)
        .use(WidgetDecoration_1.WidgetDecoration)
        .use(SelectionContext_1.SelectionContext, (_e = opts.selectionContext) !== null && _e !== void 0 ? _e : {});
    if (opts.commandMenu)
        builder.use(CommandMenu_1.CommandMenu, opts.commandMenu);
    builder.use(FilePaste_1.FilePaste);
    builder.use(ClicksOnEdges_1.ClicksOnEdges);
};
exports.BehaviorPreset = BehaviorPreset;
