"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Image = exports.imgType = exports.ImageAttr = exports.imageType = exports.imageNodeName = void 0;
const lodash_1 = require("../../../lodash");
const ImageSpecs_1 = require("./ImageSpecs");
const actions_1 = require("./actions");
const const_1 = require("./const");
const imageUrlPaste_1 = require("./imageUrlPaste");
var ImageSpecs_2 = require("./ImageSpecs");
Object.defineProperty(exports, "imageNodeName", { enumerable: true, get: function () { return ImageSpecs_2.imageNodeName; } });
Object.defineProperty(exports, "imageType", { enumerable: true, get: function () { return ImageSpecs_2.imageType; } });
Object.defineProperty(exports, "ImageAttr", { enumerable: true, get: function () { return ImageSpecs_2.ImageAttr; } });
/** @deprecated Use `imageType` instead */
exports.imgType = ImageSpecs_1.imageType;
const Image = (builder, opts) => {
    builder.use(ImageSpecs_1.ImageSpecs);
    builder.addAction(const_1.addImageAction, ({ schema }) => (0, actions_1.addImage)(schema));
    if ((0, lodash_1.isFunction)(opts === null || opts === void 0 ? void 0 : opts.parseInsertedUrlAsImage)) {
        builder.use(imageUrlPaste_1.imageUrlPaste, {
            parseInsertedUrlAsImage: opts.parseInsertedUrlAsImage,
        });
    }
};
exports.Image = Image;
