"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkPlaceholderWidget = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../../../../classname");
const LinkForm_1 = require("../../../../forms/LinkForm");
const widgets_1 = require("../../../../i18n/widgets");
const b = (0, classname_1.cn)('link-placeholder-widget');
const placement = ['bottom-start', 'top-start', 'bottom-end', 'top-end'];
const LinkPlaceholderWidget = ({ onCancel, onSubmit, }) => {
    const divRef = react_1.default.useRef(null);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", { ref: divRef, className: b() },
            react_1.default.createElement("a", { href: "#" }, (0, widgets_1.i18n)('link'))),
        react_1.default.createElement(uikit_1.Popup, { open: true, onClose: onCancel, anchorRef: divRef, placement: placement },
            react_1.default.createElement(LinkForm_1.LinkForm, { autoFocus: true, onSubmit: onSubmit, onCancel: onCancel }))));
};
exports.LinkPlaceholderWidget = LinkPlaceholderWidget;
