"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableCellFloatingButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const TableCellFloatingButton = ({ dom, actions }) => {
    if (!dom) {
        return null;
    }
    return (react_1.default.createElement(uikit_1.Popup, { open: true, keepMounted: false, hasArrow: false, anchorRef: { current: dom }, offset: [2, -12], placement: "left-start" },
        react_1.default.createElement(uikit_1.DropdownMenu, { icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.Ellipsis, size: 12, className: "table-cell-floating-icon" }), defaultSwitcherClassName: "table-cell-floating-button", items: actions.map(buildMenuItem) })));
};
exports.TableCellFloatingButton = TableCellFloatingButton;
exports.TableCellFloatingButton.displayName = 'TableCellFloatingButton';
function buildMenuItem(floatingAction) {
    if (Array.isArray(floatingAction)) {
        // @ts-expect-error
        return floatingAction.map(buildMenuItem);
    }
    const { action, text } = floatingAction;
    const active = action.isActive();
    const disabled = !active && !action.isEnable();
    return {
        text,
        action: () => action.run(),
        active,
        disabled,
    };
}
