"use strict";
var _TableCellContextView_view, _TableCellContextView_actions, _TableCellContextView_nodeType, _TableCellContextView_renderItem;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableCellContextView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const prosemirror_utils_1 = require("prosemirror-utils");
const ErrorBoundary_1 = require("../../../../../react-utils/ErrorBoundary");
const ReactRenderer_1 = require("../../../../behavior/ReactRenderer");
const floating_1 = require("./floating");
class TableCellContextView {
    constructor(view, actions, cellNodeType) {
        _TableCellContextView_view.set(this, void 0);
        _TableCellContextView_actions.set(this, void 0);
        _TableCellContextView_nodeType.set(this, void 0);
        _TableCellContextView_renderItem.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _TableCellContextView_view, view, "f");
        tslib_1.__classPrivateFieldSet(this, _TableCellContextView_actions, actions, "f");
        tslib_1.__classPrivateFieldSet(this, _TableCellContextView_nodeType, cellNodeType, "f");
        tslib_1.__classPrivateFieldSet(this, _TableCellContextView_renderItem, (0, ReactRenderer_1.getReactRendererFromState)(view.state).createItem('table-cell-tooltip', () => (react_1.default.createElement(ErrorBoundary_1.ErrorLoggerBoundary, null,
            react_1.default.createElement(floating_1.TableCellFloatingButton, { actions: tslib_1.__classPrivateFieldGet(this, _TableCellContextView_actions, "f"), dom: TableCellContextView.findCellDom(tslib_1.__classPrivateFieldGet(this, _TableCellContextView_view, "f"), tslib_1.__classPrivateFieldGet(this, _TableCellContextView_nodeType, "f")) })))), "f");
    }
    static findCellDom(view, nodeType) {
        return (0, prosemirror_utils_1.findParentDomRefOfType)(nodeType, view.domAtPos.bind(view))(view.state.selection);
    }
    update(view) {
        tslib_1.__classPrivateFieldSet(this, _TableCellContextView_view, view, "f");
        tslib_1.__classPrivateFieldGet(this, _TableCellContextView_renderItem, "f").rerender();
    }
    destroy() {
        tslib_1.__classPrivateFieldGet(this, _TableCellContextView_renderItem, "f").remove();
    }
}
exports.TableCellContextView = TableCellContextView;
_TableCellContextView_view = new WeakMap(), _TableCellContextView_actions = new WeakMap(), _TableCellContextView_nodeType = new WeakMap(), _TableCellContextView_renderItem = new WeakMap();
