"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImgSettingsButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../../../../../classname");
const common_1 = require("../../../../../i18n/common");
const hooks_1 = require("../../../../../react-utils/hooks");
const ImageForm_1 = require("./ImageForm");
const b = (0, classname_1.cn)('img-settings-button');
const ImgSettingsButton = function ({ node, view, updateAttributes, visible, edit, toggleEdit, nodeRef, unsetEdit, onDelete, }) {
    const [popupOpen, setPopupOpen, unsetPopupOpen] = (0, hooks_1.useBooleanState)(false);
    const placement = ['bottom-end', 'bottom-start'];
    const buttonRef = (0, react_1.useRef)(null);
    const handleEdit = () => {
        toggleEdit();
        unsetPopupOpen();
    };
    const isVisibleImageForm = edit;
    const isVisibleEditButton = !edit && (visible || popupOpen);
    const isVisiblePopup = !edit && popupOpen;
    const handleEditButtonClick = (event) => {
        event.preventDefault();
        setPopupOpen();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        isVisibleImageForm && (react_1.default.createElement(ImageForm_1.ImageForm, { node: node, view: view, updateAttributes: updateAttributes, dom: nodeRef, unsetEdit: unsetEdit })),
        isVisibleEditButton && (react_1.default.createElement(uikit_1.Button, { onClick: handleEditButtonClick, ref: buttonRef, size: "s", view: 'raised', className: b() },
            react_1.default.createElement(uikit_1.Icon, { data: icons_1.Ellipsis }))),
        react_1.default.createElement(uikit_1.Popup, { open: isVisiblePopup, anchorRef: buttonRef, onClose: unsetPopupOpen, placement: placement },
            react_1.default.createElement(uikit_1.Menu, null,
                react_1.default.createElement(uikit_1.Menu.Item, { onClick: handleEdit }, (0, common_1.i18n)('edit')),
                react_1.default.createElement(uikit_1.Menu.Item, { onClick: onDelete }, (0, common_1.i18n)('delete'))))));
};
exports.ImgSettingsButton = ImgSettingsButton;
