"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilePlaceholder = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const react_use_1 = require("react-use");
const classname_1 = require("../../../../classname");
const FileForm_1 = require("../../../../forms/FileForm");
const widgets_1 = require("../../../../i18n/widgets");
const hooks_1 = require("../../../../react-utils/hooks");
const b = (0, classname_1.cn)('file-placeholder');
const placement = ['bottom-start', 'top-start', 'bottom-end', 'top-end'];
const FilePlaceholder = ({ onCancel, onSubmit, onAttach }) => {
    const isMounted = (0, react_use_1.useMountedState)();
    const [loading, showLoading, hideLoading] = (0, hooks_1.useBooleanState)(false);
    const divRef = react_1.default.useRef(null);
    const attachHandler = react_1.default.useCallback((files) => {
        if (!onAttach)
            return;
        if (isMounted()) {
            showLoading();
            onAttach(files).finally(() => {
                if (isMounted()) {
                    hideLoading();
                }
            });
        }
    }, [isMounted, onAttach, showLoading, hideLoading]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", { ref: divRef, className: b() },
            react_1.default.createElement("a", { href: "#", className: "yfm-file" },
                react_1.default.createElement("span", { className: "yfm-file__icon" }),
                (0, widgets_1.i18n)('file'))),
        react_1.default.createElement(uikit_1.Popup, { open: true, onClose: onCancel, anchorRef: divRef, placement: placement },
            react_1.default.createElement(FileForm_1.FileForm, { autoFocus: true, loading: loading, onCancel: onCancel, onSubmit: onSubmit, onAttach: onAttach && attachHandler }))));
};
exports.FilePlaceholder = FilePlaceholder;
