"use strict";
var _Editor_cm;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Editor = void 0;
const tslib_1 = require("tslib");
class Editor {
    constructor(cm) {
        _Editor_cm.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _Editor_cm, cm, "f");
    }
    get cm() {
        return tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f");
    }
    get codemirror() {
        return tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f");
    }
    focus() {
        return tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").focus();
    }
    hasFocus() {
        return tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").hasFocus;
    }
    getValue() {
        return tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.doc.toString();
    }
    isEmpty() {
        return (tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.doc.lines === 1 && tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.doc.line(1).text.trim().length === 0);
    }
    clear() {
        this.replace('');
    }
    replace(newMarkup) {
        tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").dispatch({ changes: { from: 0, to: tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.doc.length, insert: newMarkup } });
    }
    prepend(markup) {
        const changes = tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.changes({
            from: 0,
            insert: this._fixMarkupBeforeInsert(markup),
        });
        tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").dispatch({ changes, selection: tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.selection.map(changes, 1) });
    }
    append(markup) {
        if (this.isEmpty()) {
            tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").dispatch({ changes: { from: 0, insert: this._fixMarkupBeforeInsert(markup) } });
            this.moveCursor('end');
            return;
        }
        const { lineBreak } = tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state;
        let insert;
        const { doc, doc: { lines }, } = tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state;
        if (lines >= 2 && doc.lineAt(lines).length === 0) {
            if (doc.lineAt(lines - 1).length === 0)
                insert = markup;
            else
                insert = lineBreak + markup;
        }
        else {
            insert = lineBreak + lineBreak + markup;
        }
        tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").dispatch({ changes: { from: doc.length, insert } });
    }
    moveCursor(position) {
        let pos;
        switch (position) {
            case 'start':
                pos = 0;
                break;
            case 'end':
                pos = tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").state.doc.length;
                break;
            default:
                throw new Error('The "position" argument must be "start" or "end"');
        }
        tslib_1.__classPrivateFieldGet(this, _Editor_cm, "f").dispatch({ selection: { anchor: pos } });
    }
    _fixMarkupBeforeInsert(markup) {
        if (markup.endsWith('\n\n'))
            return markup;
        if (markup.endsWith('\n'))
            return markup + '\n';
        return markup + '\n\n';
    }
}
exports.Editor = Editor;
_Editor_cm = new WeakMap();
