"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonMarkSpecsPreset = void 0;
const specs_1 = require("../extensions/markdown/specs");
const lodash_1 = require("../lodash");
const zero_1 = require("./zero");
const CommonMarkSpecsPreset = (builder, opts) => {
    var _a, _b, _c;
    builder.use(zero_1.ZeroPreset, opts);
    builder
        .use(specs_1.Html)
        .use(specs_1.BoldSpecs)
        .use(specs_1.ItalicSpecs)
        .use(specs_1.CodeSpecs)
        .use(specs_1.LinkSpecs)
        .use(specs_1.ListsSpecs)
        .use(specs_1.BlockquoteSpecs)
        .use(specs_1.HorizontalRuleSpecs)
        .use(specs_1.BreaksSpecs, (_a = opts.breaks) !== null && _a !== void 0 ? _a : {})
        .use(specs_1.CodeBlockSpecs, (_b = opts.codeBlock) !== null && _b !== void 0 ? _b : {});
    if (opts.image !== false) {
        builder.use((0, lodash_1.isFunction)(opts.image) ? opts.image : specs_1.ImageSpecs);
    }
    if (opts.heading !== false) {
        if ((0, lodash_1.isFunction)(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(specs_1.HeadingSpecs, (_c = opts.heading) !== null && _c !== void 0 ? _c : {});
    }
};
exports.CommonMarkSpecsPreset = CommonMarkSpecsPreset;
