"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmSpecsPreset = void 0;
const specs_1 = require("../extensions/specs");
const specs_2 = require("../extensions/yfm/specs");
const default_specs_1 = require("./default-specs");
const YfmSpecsPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    builder.use(default_specs_1.DefaultSpecsPreset, Object.assign(Object.assign({}, opts), { image: false, heading: false }));
    builder
        .use(specs_1.DeflistSpecs, (_a = opts.deflist) !== null && _a !== void 0 ? _a : {})
        .use(specs_1.SubscriptSpecs)
        .use(specs_1.SuperscriptSpecs)
        .use(specs_1.UnderlineSpecs)
        .use(specs_2.CheckboxSpecs, (_b = opts.checkbox) !== null && _b !== void 0 ? _b : {})
        .use(specs_2.ImgSizeSpecs, (_c = opts.imgSize) !== null && _c !== void 0 ? _c : {})
        .use(specs_2.MonospaceSpecs)
        .use(specs_2.VideoSpecs, (_d = opts.video) !== null && _d !== void 0 ? _d : {})
        .use(specs_2.YfmConfigsSpecs, (_e = opts.yfmConfigs) !== null && _e !== void 0 ? _e : {})
        .use(specs_2.YfmCutSpecs, (_f = opts.yfmCut) !== null && _f !== void 0 ? _f : {})
        .use(specs_2.YfmNoteSpecs, (_g = opts.yfmNote) !== null && _g !== void 0 ? _g : {})
        .use(specs_2.YfmFileSpecs)
        .use(specs_2.YfmHeadingSpecs, (_h = opts.yfmHeading) !== null && _h !== void 0 ? _h : {})
        .use(specs_2.YfmTableSpecs, (_j = opts.yfmTable) !== null && _j !== void 0 ? _j : {})
        .use(specs_2.YfmTabsSpecs, (_k = opts.yfmTabs) !== null && _k !== void 0 ? _k : {});
};
exports.YfmSpecsPreset = YfmSpecsPreset;
