"use strict";
var _ShortCutFormatter_map;
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatter = void 0;
const tslib_1 = require("tslib");
const platform_1 = require("../utils/platform");
const const_1 = require("./const");
class ShortCutFormatter {
    constructor() {
        _ShortCutFormatter_map.set(this, new Map());
    }
    set(name, defs) {
        if (Array.isArray(defs)) {
            tslib_1.__classPrivateFieldGet(this, _ShortCutFormatter_map, "f").set(name, defs);
        }
        else {
            const platformedDefs = defs[(0, platform_1.isMac)() ? 'mac' : 'pc'];
            if (platformedDefs) {
                tslib_1.__classPrivateFieldGet(this, _ShortCutFormatter_map, "f").set(name, platformedDefs);
            }
        }
        return this;
    }
    toPM(name) {
        const defs = tslib_1.__classPrivateFieldGet(this, _ShortCutFormatter_map, "f").get(name);
        if (!defs)
            return null;
        return defs.join('-');
    }
    toCM(name) {
        const defs = tslib_1.__classPrivateFieldGet(this, _ShortCutFormatter_map, "f").get(name);
        if (!defs)
            return null;
        return defs.sort((a) => (a === const_1.ModKey.Shift ? -1 : 0)).join('-');
    }
    toView(name) {
        const defs = tslib_1.__classPrivateFieldGet(this, _ShortCutFormatter_map, "f").get(name);
        return defs === null || defs === void 0 ? void 0 : defs.join('+');
    }
}
_ShortCutFormatter_map = new WeakMap();
exports.formatter = new ShortCutFormatter();
