"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withMermaid = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_2 = require("@diplodoc/mermaid-extension/react");
const useMermaidRuntime_1 = require("./useMermaidRuntime");
function withMermaid(opts) {
    return (Component) => (0, react_1.forwardRef)(function WithLatex(props, ref) {
        const { meta, html, mermaidConfig } = props;
        const renderMermaid = (0, react_2.useMermaid)();
        (0, useMermaidRuntime_1.useMermaidRuntime)(meta, opts.runtime);
        (0, react_1.useEffect)(() => {
            renderMermaid(mermaidConfig);
        }, [html, mermaidConfig, renderMermaid]);
        return react_1.default.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
exports.withMermaid = withMermaid;
