import React from 'react';
import { ClassNameProps } from '../classname';
import { ToolbarData, ToolbarItemData } from '../toolbar';
import type { EditorInt } from './Editor';
import type { MarkdownEditorMode } from './types';
export declare type ToolbarViewProps<T> = ClassNameProps & {
    editor: EditorInt;
    editorMode: MarkdownEditorMode;
    toolbarEditor: T;
    toolbarFocus: () => void;
    toolbarConfig: ToolbarData<T>;
    settingsVisible?: boolean;
    hiddenActionsConfig?: ToolbarItemData<T>[];
    children?: React.ReactNode;
    stickyToolbar: boolean;
};
export declare function ToolbarView<T>({ editor, editorMode, toolbarEditor, toolbarFocus, toolbarConfig, hiddenActionsConfig, settingsVisible, className, children, stickyToolbar, }: ToolbarViewProps<T>): JSX.Element;
