import { ClicksOnEdges } from './ClicksOnEdges';
import { Clipboard } from './Clipboard';
import { CommandMenu } from './CommandMenu';
import { Cursor } from './Cursor';
import { FilePaste } from './FilePaste';
import { History } from './History';
import { Placeholder } from './Placeholder';
import { ReactRendererExtension } from './ReactRenderer';
import { Selection } from './Selection';
import { SelectionContext } from './SelectionContext';
import { WidgetDecoration } from './WidgetDecoration';
export * from './ClicksOnEdges';
export * from './Clipboard';
export * from './CommandMenu';
export * from './Cursor';
export * from './FilePaste';
export * from './History';
export * from './Placeholder';
export * from './ReactRenderer';
export * from './Selection';
export * from './SelectionContext';
export * from './WidgetDecoration';
export const BehaviorPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e;
    builder
        .use(Selection)
        .use(Placeholder, (_a = opts.placeholder) !== null && _a !== void 0 ? _a : {})
        .use(Cursor, (_b = opts.cursor) !== null && _b !== void 0 ? _b : {})
        .use(History, (_c = opts.history) !== null && _c !== void 0 ? _c : {})
        .use(Clipboard, (_d = opts.clipboard) !== null && _d !== void 0 ? _d : {})
        .use(ReactRendererExtension, opts.reactRenderer)
        .use(WidgetDecoration)
        .use(SelectionContext, (_e = opts.selectionContext) !== null && _e !== void 0 ? _e : {});
    if (opts.commandMenu)
        builder.use(CommandMenu, opts.commandMenu);
    builder.use(FilePaste);
    builder.use(ClicksOnEdges);
};
