import { isFunction } from '../../../lodash';
import { ImageSpecs, imageType } from './ImageSpecs';
import { addImage } from './actions';
import { addImageAction } from './const';
import { imageUrlPaste } from './imageUrlPaste';
export { imageNodeName, imageType, ImageAttr } from './ImageSpecs';
/** @deprecated Use `imageType` instead */
export const imgType = imageType;
export const Image = (builder, opts) => {
    builder.use(ImageSpecs);
    builder.addAction(addImageAction, ({ schema }) => addImage(schema));
    if (isFunction(opts === null || opts === void 0 ? void 0 : opts.parseInsertedUrlAsImage)) {
        builder.use(imageUrlPaste, {
            parseInsertedUrlAsImage: opts.parseInsertedUrlAsImage,
        });
    }
};
