import { toggleMark } from 'prosemirror-commands';
import { createToggleMarkAction } from '../../../utils/actions';
import { markInputRule } from '../../../utils/inputrules';
import { withLogAction } from '../../../utils/keymap';
import { StrikeSpecs, strikeMarkName, strikeType } from './StrikeSpecs';
export { strikeMarkName, strikeType } from './StrikeSpecs';
/** @deprecated Use `strikeMarkName` instead */
export const strike = strikeMarkName;
const sAction = 'strike';
export const Strike = (builder, opts) => {
    builder.use(StrikeSpecs);
    builder
        .addAction(sAction, ({ schema }) => createToggleMarkAction(strikeType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            markInputRule({ open: '~~', close: '~~', ignoreBetween: '~' }, strikeType(schema)),
        ],
    }));
    if (opts === null || opts === void 0 ? void 0 : opts.strikeKey) {
        const { strikeKey } = opts;
        builder.addKeymap(({ schema }) => ({
            [strikeKey]: withLogAction('strike', toggleMark(strikeType(schema))),
        }));
    }
};
