import { Node } from 'prosemirror-model';
import { EditorView } from 'prosemirror-view';
import { FileUploadHandler, UploadSuccessItem } from '../../../../utils';
import { FilesBatchUploadProcess } from '../../../behavior/utils/upload';
import { CreateImageNodeOptions } from '../utils';
import { ImageSkeletonDescriptor } from './skeleton';
export declare class ImagesUploadProcess extends FilesBatchUploadProcess {
    protected readonly createImage: ({ result, file }: UploadSuccessItem) => Promise<Node>;
    protected readonly initPosition: number;
    private readonly enableNewImageSizeCalculation?;
    constructor(view: EditorView, files: readonly File[], uploadHandler: FileUploadHandler, position: number, opts: CreateImageNodeOptions);
    protected createSkeleton(): Promise<ImageSkeletonDescriptor>;
    protected createPMNode(res: UploadSuccessItem): Promise<Node>;
}
