import { BlockquoteSpecs, BoldSpecs, BreaksSpecs, CodeBlockSpecs, CodeSpecs, HeadingSpecs, HorizontalRuleSpecs, Html, ImageSpecs, ItalicSpecs, LinkSpecs, ListsSpecs, } from '../extensions/markdown/specs';
import { isFunction } from '../lodash';
import { ZeroPreset } from './zero';
export const CommonMarkSpecsPreset = (builder, opts) => {
    var _a, _b, _c;
    builder.use(ZeroPreset, opts);
    builder
        .use(Html)
        .use(BoldSpecs)
        .use(ItalicSpecs)
        .use(CodeSpecs)
        .use(LinkSpecs)
        .use(ListsSpecs)
        .use(BlockquoteSpecs)
        .use(HorizontalRuleSpecs)
        .use(BreaksSpecs, (_a = opts.breaks) !== null && _a !== void 0 ? _a : {})
        .use(CodeBlockSpecs, (_b = opts.codeBlock) !== null && _b !== void 0 ? _b : {});
    if (opts.image !== false) {
        builder.use(isFunction(opts.image) ? opts.image : ImageSpecs);
    }
    if (opts.heading !== false) {
        if (isFunction(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(HeadingSpecs, (_c = opts.heading) !== null && _c !== void 0 ? _c : {});
    }
};
