import React from 'react';
export const ToasterContext = React.createContext(null);
ToasterContext.displayName = 'YEToasterContext';
export function useToaster() {
    const toaster = React.useContext(ToasterContext);
    if (!toaster) {
        throw new Error('YEToaster: `useToaster` hook is used out of context');
    }
    return React.useMemo(() => toaster, [toaster]);
}
