import { Fragment } from 'prosemirror-model';
import { findParentNodeClosestToPos } from 'prosemirror-utils';
import { isTableNode } from '..';
import { trackTransactionMetrics } from '../../core';
import { TableDesc } from '../table-desc';
export const removeRow = (state, dispatch, _, attrs = {}) => {
    var _a;
    const { tablePos, rowNumber } = attrs;
    if (tablePos === undefined || rowNumber === undefined)
        return false;
    const tableNode = (_a = findParentNodeClosestToPos(state.doc.resolve(tablePos + 1), isTableNode)) === null || _a === void 0 ? void 0 : _a.node;
    if (!tableNode)
        return false;
    const tableDesc = TableDesc.create(tableNode);
    if (!tableDesc || rowNumber >= tableDesc.rows)
        return false;
    if (!tableDesc.isSafeRow(rowNumber))
        return false;
    if (dispatch) {
        let { from, to } = tableDesc.getRelativePosForRow(rowNumber);
        from += tablePos;
        to += tablePos;
        dispatch(trackTransactionMetrics(state.tr.replaceWith(from, to, Fragment.empty), 'removeRow', {
            rows: tableDesc.rows,
            cols: tableDesc.cols,
        }));
    }
    return true;
};
