import { __rest } from "tslib";
import React, { useRef } from 'react';
import { useBoolean } from 'react-use';
import { ToolbarButtonView } from './ToolbarButton';
export function ToolbarButtonPopup(props) {
    const { className, editor, isActive, isEnable, renderPopup } = props, buttonProps = __rest(props, ["className", "editor", "isActive", "isEnable", "renderPopup"]);
    const buttonRef = useRef(null);
    const [open, setOpen] = useBoolean(false);
    const active = isActive(editor);
    const enabled = isEnable(editor);
    return (React.createElement(React.Fragment, null,
        React.createElement(ToolbarButtonView, Object.assign({}, buttonProps, { ref: buttonRef, active: active, enabled: enabled, className: className, onClick: () => setOpen() })),
        open &&
            renderPopup(Object.assign(Object.assign({}, props), { anchorRef: buttonRef, hide: () => setOpen(false) }))));
}
