import React, { forwardRef, useEffect } from 'react';
import { useLatex } from '@diplodoc/latex-extension/react';
import { useLatexRuntime } from './useLatexRuntime';
export function withLatex(opts) {
    return (Component) => forwardRef(function WithLatex(props, ref) {
        const { meta, html } = props;
        const renderLatex = useLatex();
        useLatexRuntime(meta, opts.runtime);
        useEffect(() => {
            renderLatex({ throwOnError: false });
        }, [html, renderLatex]);
        return React.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
