import React, { forwardRef, useEffect } from 'react';
import { useMermaid } from '@diplodoc/mermaid-extension/react';
import { useMermaidRuntime } from './useMermaidRuntime';
export function withMermaid(opts) {
    return (Component) => forwardRef(function WithLatex(props, ref) {
        const { meta, html, mermaidConfig } = props;
        const renderMermaid = useMermaid();
        useMermaidRuntime(meta, opts.runtime);
        useEffect(() => {
            renderMermaid(mermaidConfig);
        }, [html, mermaidConfig, renderMermaid]);
        return React.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
